program scorched;
include "data/terragbg.prg"
	const
		nbweapons = 11;
	global
  turn;
	playerid[6];
	playerdamage[6][6];
	nbplayers=2;
	shot =0;
	falling = 0;
	turndone=0;
	float gravity = 0.02;
	float wind = 0.00;
	windon=1;
	musicon=1;
	alive;
	button;
	nbinterpolationpoints=13;
	nbofsegments=4;
	maxlandheight=200;
	exploding=0;
	playermenu=1;
	playercolor[6]=1,2,3,4,5,6;
	playerai[6]=0,1,1,1,1,1;
	playerscore[6]=0,0,0,0,0,0;
	playermoney[6]=0,0,0,0,0,0;
	string weaponnames[nbweapons]="tracer","grenade","big grenade","digger","bigger digger","roller","heavy roller","rapid fire","leaper","flow","funky bomb";
	startweapons[nbweapons]=-1,-1,0,-1,0,0,0,0,0,0,0;
	weaponprices[nbweapons]=5,50,750,50,500,1000,3000,2500,2000,10000,7500;
	Playerweapons[6][nbweapons];
	sound[10];
	music;
	nbrounds=3;
	round=0;             
	landcolors[4]=34,40,5,10;
	compbuys=1;
local
	trash;
  power=50;
	shootangle=0;
	health=100;
	weapon=1;
begin
	SET_MODE(320,240,8);
	load_fpg("Scorched.fpg");
	splashscreen(160,120);
	frame;
	frame;
	sound[0] = load_wav("Sound/Rpdfire.wav");
	sound[1] = load_wav("Sound/shot2.wav");
	sound[2] = load_wav("Sound/impact.wav");
	x=0;
	makeland(nbinterpolationpoints,nbofsegments,landcolors[2],landcolors[3],landcolors[0],landcolors[1],240-maxlandheight,240);
	write(0,160,200,4,"press B to begin");
	while(!key(_alt))
		x++;
		if(x%200 ==0)
			frame;
		end;
	end;
	rand_seed(x);
	//makeland(nbinterpolationpoints,nbofsegments,landcolors[2],landcolors[3],landcolors[0],landcolors[1],240-maxlandheight,240);
	menu();
	return;
end;
/*
M   M EEEE N   N U  U
MM MM E    NN  N U  U
M M M EEE  N N N U  U 
M   M E    N  NN U  U
M   M EEEE N   N  UU
*/
process splashscreen(x,y);
begin
	graph = 23;
	loop
		frame;
	end;
end;
/*
little wait loop, temporarily freezes the proces that calls it :)
best do a frame after using it, or it might no work :)
*/
process wait(time);
begin
	signal(father,s_freeze);
	timer[1]=0;
	while(timer[1]<time)
	frame;
	end;
	signal(father,s_wakeup);
	return;
end;
function music(string newmusic)
private
	i;
begin
	if(musicon)
		stop_song();
		while(i<100000)
		i++;
		end;
		unload_song(music);
		music = LOAD_SONG(newmusic);
		play_song(music,-1);
	else
		STOP_SONG();
		unload_song(music);
	end;
	return;
end;
/*
the main menu :)
*/
process menu();
begin
	LET_ME_ALONE();//kill all other processes, wise thing ;)
	button=0;//and we start at the first button again :)
	delete_text(0);//all text must be removed
	button(160,40,"play",0);//and we create the buttons :)
	button(160,80,"players",1);
	button(160,120,"settings",2);
	button(160,160,"landscape",3);
	loop
		frame;//and in the loop we draw
		if(key(_up))//check for any buttonmovement :)
			button--;
			wait(15);
		elseif(key(_down))
			button=(button+1)mod(4);
			wait(15);
		end;
		if(IS_PLAYING_SONG() != musicon)
			music("music/d3d.mod");
		end;
		if(button<0)//make sure buttons don't go out of range :)
			button =3;
		end;
		if(key(_control))//and let u use a button duh :p
			switch(button)
				case(0):wait(25);frame;newgame();end
				case(1):wait(5);frame;playermenu(0);end
				case(2):wait(5);frame;settingsmenu();end
				case(3):wait(5);frame;landmenu();end;
			end;
		end;
	end;
end;
process settingsmenu()
begin
	LET_ME_ALONE();//identical to menu() :)
	delete_text(0);
	button = 0;
	buttononof(160,40,"wind: ",0,&windon,10);
	buttononof(160,80,"music: ",1,&musicon,10);
	button(160,120,"weapons",2);
	buttonvalue(160,160,"rounds",3,&nbrounds,1,99,1);
	buttononof(160,200,"AIbuys ",4,&compbuys,10);
	loop
		frame;
		if(key(_up))
			button--;
			wait(15);
		elseif(key(_down))
			button=(button+1)mod(5);
			wait(15);
		end;
		if(button<0)
			button =4;
		end;
		if(key(_alt))
			menu();
			return;
		end;
		if(key(_control));
		  switch(button)
				case(2):wait(15);frame;weaponsmenu(&startweapons);end
			end;
		end;
	end;
end;
/*
the menu for for land settings and generation
*/
process landmenu();//menu for land generation :)
begin
	LET_ME_ALONE();//identical to menu() :)
	delete_text(0);
	button = 0;
	buttonvalue(160,40,"nb points",0,&nbinterpolationpoints,4,20,1);
	buttonvalue(160,80,"nb segments",1,&nbofsegments,1,5,1);
	buttonvalue(160,120,"max height",2,&maxlandheight,40,240,10);
	button(160,160,"generate",3);
	loop
		frame;
		if(key(_up))
			button--;
			wait(15);
		elseif(key(_down))
			button=(button+1)mod(4);
			wait(15);
		end;
		if(button<0)
			button =3;
		end;
		if(key(_alt))
			menu();
			return;
		end;
		if(key(_control))
			switch(button)
				case(3):wait(25);frame;makeland(nbinterpolationpoints,nbofsegments,landcolors[2],landcolors[3],landcolors[0],landcolors[1],240-maxlandheight,240);end
			end;
		end;
	end;
end;
/*
menu for player settings and generation :)
*/
process playermenu(sbutton);//menu for land generation :)
begin
	button = sbutton;
	LET_ME_ALONE();//identical to menu() :)
	delete_text(0);
	playerbuttonvalue(160,40,"number",0,&nbplayers,2,6,1);
	playerbuttonvalue(160,80,"player",1,&playermenu,1,nbplayers,1);
	buttonpic(160,120,"color",2,&playercolor[playermenu-1],1,6,1);
	buttonai(160,160,"",3,&playerai[playermenu-1],0,3,1);
	loop
		frame;
		if(key(_up))
			button--;
			wait(15);
		elseif(key(_down))
			button=(button+1)mod(4);
			wait(15);
		end;
		if(button<0)
			button =3;
		end;
		if(key(_alt))
			menu();
			return;
		end;
	end;
end;
/*
process that creates a button
*/
process button(x,y,string text,int number)
begin
	graph=19;
	size=400;
	write(0,x,y,4,text);
	loop
		frame;
		if(button==number)
			graph=18;
		else
			graph=19;
		end;
	end;
end;
/*
the AI button in the players menu :)
*/
process buttonai(x,y,string text,int number,pointer value,int low,int high,stepping)
begin
	graph=19;
	size=400;
	WRITE_STRING(0,x,y,4,&text);
	loop
		frame;
		if(button==number)
			graph=18;
			if(key(_left))
				wait(15);frame;
				(*value)-=stepping;
			elseif(key(_right))
				wait(15);frame;
			  (*value)+=stepping;
			end;	
		else
			graph=19;
		end;
		if(*value>high)
			*value=low;
		end;
		if(*value<low)
			*value=high;
		end;
		switch(*value)
			case(0):text="human";end
			case(1):text="easy";end
			case(2):text="medium";end
			case(3):text="hard";end
		end;
	end;
end;
/*
process that creates a button that manipulates a value :) (to which the pointer is given)
*/
process buttononof(x,y,string text,int number,pointer value,int alignment)
private
	string onof;
begin
	graph=19;
	size=400;
	write(0,x+10,y,5,text);
	write_string(0,x+10,y,3,&onof);
	loop
		frame;
		if(button==number)
			graph=18;
			if(key(_left))
				wait(15);frame;
				(*value)-=1;
			elseif(key(_right))
				wait(15);frame;
			  (*value)+=1;
			end;	
		else
			graph=19;
		end;
		if(*value>1)
			*value=0;
		end;
		if(*value<0)
			*value=1;
		end;
		switch(*value)
			case (0):onof="off";end
			case (1):onof="on";end
		end;
	end;
end;
/*
process that creates a button that manipulates a value :) (to which the pointer is given)
*/
process buttonvalue(x,y,string text,int number,pointer value,int low,int high,stepping)
private
	box;
begin
	graph=19;
	size=400;
	write(0,x,y,4,text);
	box = valuebox(x+70,y,value);
	loop
		frame;
		if(button==number)
			graph=18;
			box.graph=20;
			if(key(_left))
				wait(15);frame;
				(*value)-=stepping;
			elseif(key(_right))
				wait(15);frame;
			  (*value)+=stepping;
			end;	
		else
			graph=19;
			box.graph=21;
		end;
		if(*value>high)
			*value=low;
		end;
		if(*value<low)
			*value=high;
		end;
	end;
end;
/*
process that creates a button that manipulates a value :) (to which the pointer is given)
this is for the player menu where values can alter eachother, so eacht change we start a new menu
*/
process playerbuttonvalue(x,y,string text,int number,pointer value,int low,int high,stepping)
private
	box;
begin
	graph=19;
	size=400;
	write(0,x,y,4,text);
	box = valuebox(x+70,y,value);
	loop
		frame;
		if(button==number)
			graph=18;
			box.graph=20;
			if(key(_left))
				wait(15);frame;
				(*value)-=stepping;
				playermenu(number);
			elseif(key(_right))
				wait(15);frame;
			  (*value)+=stepping;
			  playermenu(number);
			end;	
		else
			graph=19;
			box.graph=21;
		end;
		if(*value>high)
			*value=low;
			playermenu(number);
		end;
		if(*value<low)
			*value=high;
			playermenu(number);
		end;
	end;
end;
/*
value box for a buttonvalue() process
*/
process valuebox(x,y,pointer value)
begin
	graph=21;
	size=400;
	write_int(0,x,y,4,value);
	loop
		frame;
	end;
end;
/*
process that creates a button that manipulates a value :) (to which the pointer is given)
this is for the player menu where values can alter eachother, so eacht change we start a new menu
*/
process buttonpic(x,y,string text,int number,pointer graphic,int low,int high,stepping)
private
	box;
begin
	graph=19;
	size=400;
	write(0,x,y,4,text);
	box = picbox(x+70,y,graphic);
	loop
		frame;
		if(button==number)
			graph=18;
			box.graph=20;
			if(key(_left))
				wait(15);frame;
				(*graphic)-=stepping;
			elseif(key(_right))
				wait(15);frame;
			  (*graphic)+=stepping;
			end;	
		else
			graph=19;
			box.graph=21;
		end;
		if(*graphic>high)
			*graphic=low;
		end;
		if(*graphic<low)
			*graphic=high;
		end;
	end;
end;
/*
value box for a buttonvalue() process
*/
process picbox(x,y,pointer graphic)
begin
	graph=21;
	size=400;
	picture(x,y,graphic);
	loop
		frame;
	end;
end;
process picture(x,y,pointer graphic)
begin
	loop
		graph= *graphic;
		frame;
	end;
end;
/*
BBB	 U  U Y   Y   M   M EEEE N   N U  U
B  B U  U  Y Y    MM MM E    NN  N U  U
BBB  U  U   Y     M M M EEE  N N N U  U
B  B U  U   Y     M   M E    N  NN U  U
BBB   UU    Y     M   M EEEE N   N  UU
*/
process weaponsmenu(pointer values)
private
	i;
begin
	LET_ME_ALONE();
	delete_text(0);
	button = 0;
	for(i=0; i<nbweapons; i++);
		bbuttonvalue(60,25+25*i,weaponnames[i],i,values+i,-1,99,1);
	end;
	loop
		frame;
		if(key(_up))
			button--;
			wait(15);
		elseif(key(_down))
			button=(button+1)mod(nbweapons);
			wait(15);
		end;
		if(button<0)
			button =nbweapons-1;
		end;
		if(key(_alt))
			settingsmenu();
			return;
		end;
	end;
end;
/*
process that creates a button that manipulates a value :) (to which the pointer is given)
*/
process bbuttonvalue(x,y,string text,int number,pointer value,int low,int high,stepping)
private
	box;
begin
	graph=25;
	size=400;
	if(y>=240)
		y-=225;
		x+=160;	
	end;
	write(0,x,y,4,text);
	box = bvaluebox(x+70,y,value);
	loop
		frame;
		if(button==number)
			graph=24;
			box.graph=27;
			if(key(_right))
				wait(15);frame;
				(*value)+=stepping;
			end
			if(key(_left))
				wait(15);frame;
				(*value)-=stepping;
			end	
		else
			graph=25;
			box.graph=28;
		end;
		if(*value>high)
			*value=low;
		end;
		if(*value<low)
			*value=high;
		end;
	end;
end;
/*
process that creates a button that manipulates a value :) (to which the pointer is given)
*/
process bwbuttonvalue(x,y,string text,int number,pointer value,int money,int low,int high,stepping)
private
	box;
	i;
	textnb;
	textstat=0;;
begin
	graph=25;
	size=400;
	if(y>200)
		y-=200;
		x+=160;	
	end;
	textnb=write(0,x,y,4,text);
	box = bvaluebox(x+70,y,value);
	loop
		if(weaponprices[number]>playermoney[money]or Playerweapons[money][number]==-1)
			if(textstat==1)
				textstat=0;
				delete_text(textnb);
				textnb=write(0,x,y,4,text);
			end;
			graph=26;
			box.graph=29;
			loop
				frame;
			end;
		end;
		frame;
		if(button==number)
			graph=24;
			box.graph=27;
			if(textstat==0)
				textstat=1;
				delete_text(textnb);
				textnb=write_int(0,x,y,4,&weaponprices[number]);
			end;
			if(key(_control)&&(*value)!=-1)
				while(key(_control))frame;end;
				(*value)+=stepping;
				playermoney[money]-=weaponprices[button];
				while(button !=nbweapons and (weaponprices[button]>playermoney[money] or Playerweapons[money][button]==-1 or Playerweapons[money][button]==99))
				button++; 
					if(button>nbweapons)
					button =0;
				end
			end
			end	
		else
			if(textstat==1)
				textstat=0;
				delete_text(textnb);
				textnb=write(0,x,y,4,text);
			end;
			graph=25;
			box.graph=28;
		end;
		if(*value>high)
			*value=low;
		end;
		if(*value<low)
			*value=high;
		end;
	end;
end;
process bwbuttondone(x,y,int number)
private
begin
	graph=25;
	size=400;
	write(0,x,y,4,"Done");
	loop
		graph=25;
		if(button == number)
			graph=24;
		end;
		frame;
	end;
end;
/*
value box for a bbuttonvalue() process
*/
process bvaluebox(x,y,pointer value)
begin
	graph=27;
	size=400;
	write_int(0,x,y,4,value);
	loop
		frame;
	end;
end;
/*
 GGG  AA  M   M EEEE
G    A  A MM MM E
G GG AAAA M M M EEE
G  G A  A M   M E
 GG  A  A M   M EEEE
*/
function resetglobals()
private
	i;
	j;
begin
	for(i=0; i<6; i++)
		for(j=0; j<6; j++)
			playerdamage[i][j]=0;
		end;
		playerscore[i]=0;
		playermoney[i]=0;
	end;
	for(i=0; i<6; i++)
		for(j=0; j<nbweapons; j++)
			Playerweapons[i][j]=startweapons[j];
		end;
	end;
	turndone=0;
  turn=0;//first player's turn again
	shot=0;//so we can shoot :p
	alive=nbplayers;//all players are alie again :)
	wind=rand(-50,50)/10000.0;
	exploding = 0;
	round=0;
	return;
end;
function resetroundglobals()
private
	i;
	j;
begin
	for(i=0; i<6; i++)
		for(j=0; j<6; j++)
			playerdamage[i][j]=0;
		end;
	end;
	turndone=0;
  turn=0;//first player's turn again
	shot=0;//so we can shoot :p
	alive=nbplayers;//all players are alie again :)
	wind=rand(-50,50)/10000.0;
	exploding = 0;
	return;
end;
process gameover()
private 
	i;
	best;
	winner;
begin
	shot=1;
	turndone=1;
	DELETE_TEXT(0);
	for(i=0; i<nbplayers; i++);//check all players
		if(playerscore[i] >best)
			winner = i+1;
			best = playerscore[i];
		end;
	end;
	WRITE(0,215,120,5,"the winner is player ");
	write_int(0,215,120,3,&winner);
	write(0,160,130,4,"press B to go back to the menu");
	loop
		if(key(_alt))
			music("music/d3d.mod");
			delete_text(0);
			write(0,160,120,4,"Loading");
			frame;
			makeland(nbinterpolationpoints,nbofsegments,landcolors[2],landcolors[3],landcolors[0],landcolors[1],240-maxlandheight,240);
			menu();
		end;
		frame;
	end;
end;
process endround(number)
private 
	i;
	winner;
	int j;
begin
	shot=1;
	turndone=1;
	DELETE_TEXT(0);
	resetroundglobals();
	for(i=0; i<nbplayers; i++);//check all players
		if(playerid[i].health >0)
			winner = i+1;
		end;
	end;
	write(0,175,50,5,"Round ");
	write_int(0,175,50,3,&number);
	WRITE(0,225,120,5,"round winner is player ");
	write_int(0,225,120,3,&winner);
	write(0,160,130,4,"press A to buy weapons");
	/*while(!key(_control))
		frame;
	end;
	while(key(_control))
		frame;
	end;*/
	for(j=1; j<=nbplayers; j++)
		LET_ME_ALONE();
		if(playerai[j-1]==0)
			delete_text(0);
			write(0,180,10,5,"Player ");
			write_int(0,180,10,3,&j);
			button = 0;
			while(button !=nbweapons and (weaponprices[button]>playermoney[j-1] or Playerweapons[j-1][button]==-1 or Playerweapons[j-1][button]==99))
				button++; 
					if(button>nbweapons)
					button =0;
				end
			end
			write_int(0,0,0,0,&playermoney[j-1]);
			for(i=0; i<nbweapons; i++);
				bwbuttonvalue(60,25+25*i,weaponnames[i],i,&playerweapons[j-1]+i,j-1,-1,99,1);
			end;
			bwbuttondone(160,225,nbweapons);
			while(!key(_control)or button!=nbweapons)
				frame;
				if(key(_up))
					button--;
					while(button !=nbweapons and (weaponprices[button]>playermoney[j-1] or Playerweapons[j-1][button]==-1 or Playerweapons[j-1][button]==99))
						button--; 
					  if(button<0)
							button =nbweapons;
						end
					end
					wait(15);frame;
				elseif(key(_down))
					button++;
					while(button !=nbweapons and (weaponprices[button]>playermoney[j-1] or Playerweapons[j-1][button]==-1 or Playerweapons[j-1][button]==99))
						button++; 
					  if(button>nbweapons)
							button =0;
						end
					end
					wait(15);frame;
				end;
			end;
			while(key(_control))
				frame;
			end;
		elseif(compbuys==1)
			while(rand(1,10)>1)//we'll let the pc attempt a few buys :), just random
				button=rand(0,nbweapons-1);
				if(weaponprices[button]<playermoney[j-1] and Playerweapons[j-1][button]!=-1 and Playerweapons[j-1][button]!=99)
					playermoney[j-1]-=weaponprices[button];
					Playerweapons[j-1][button]+=1; 
				end;
			end;	
		end;
	end;
	LET_ME_ALONE();
	delete_text(0);
	write(0,160,120,4,"Loading");
	frame;
	makeland(nbinterpolationpoints,nbofsegments,landcolors[2],landcolors[3],landcolors[0],landcolors[1],240-maxlandheight,240);
	resetroundglobals();
	DELETE_TEXT(0);
	game();
	loop
		frame;
		if(key(_enter))
			gameover();
		end;
	end;
end;
process newgame()
begin
	DELETE_TEXT(0);
	timer[0]=0;
	LET_ME_ALONE();
	music("music/play.mod");
	wait(20);frame;
	resetglobals();//important, otherwise we might still be shooting/wrong amount of players alive,...
	game();
	loop
		frame;
		if(key(_enter))
			gameover();
		end;
	end;
end;
/*
this process spawns the players, and keeps track of the info on the screen (wind, health,..)
*/
process game()
private
	j;
	currentangle;
	currentpower;
	currentturn;
	currenthealth;
	currentscore;
	string currentweapon;
	arrow;
	crosshair;
	currentwind;
	string strwind = "wind  : ";
	supply;
begin
	arrow = arrow();//create the arrow
	crosshair = crosshair();//create the crosshair
	for(j=0; j<nbplayers; j++)//place all players randomly
		playerid[j]=tank(getposition(j),playercolor[j],playerai[j],j);
		signal(playerid[j],s_freeze);
	end;
	signal(playerid[turn],s_wakeup);
	WRITE(0,130,10,5,"angle: ");//write all info on top
	write_int(0,130,10,3,&currentangle);
	WRITE(0,200,10,5,"power: ");
	write_int(0,200,10,3,&currentpower);
	WRITE(0,295,10,5,"player: ");
	write_int(0,295,10,3,&currentturn);
	WRITE(0,295,20,5,"health: ");
	write_int(0,295,20,3,&currenthealth);
	WRITE_STRING(0,135,20,5,&strwind);
	write_int(0,135,20,3,&currentwind);
	WRITE(0,200,20,5,"score: ");
	write_int(0,200,20,3,&currentscore);
	WRITE(0,40,10,4,"weapon");
	write_string(0,40,20,4,&currentweapon);
	WRITE(0,60,30,5,"supply: ");
	write_int(0,60,30,3,&supply);
	loop//keep track of all the info :)$
		supply = playerweapons[turn][playerid[turn].weapon];
		currentscore = playerscore[turn];
		if(alive <=1);//if only 1 or less tanks are alive, gameover :p
			if(++round>=nbrounds)
				gameover();
			else
				endround(round);
			end;
		end;
		wind *= windon;
		currentwind = abs(wind*10000);//keep track of the wind
		if(currentwind == 0)
			strwind = "wind  : ";
		end;
		if(wind < 0)
			strwind = "wind<=: ";
		end;
		if(wind > 0)
			strwind = "wind=>: ";
		end;
		crosshair.x=playerid[turn].x+15*sin(playerid[turn].shootangle);//coordinates alter with aim
		crosshair.y=playerid[turn].y-15*cos(playerid[turn].shootangle);
		arrow.x=playerid[turn].x;
		arrow.y=playerid[turn].y-20;
		currentturn = turn+1;
		currentangle = playerid[turn].shootangle/1000+90;
		currentpower = playerid[turn].power;
		currenthealth= playerid[turn].health;
		currentweapon = weaponnames[playerid[turn].weapon];	
		frame;
	end;
end;
/*
method that moves to the next player :)
*/
process nextplayer()//the radius is so we know how far tanks can fall!
private
	i;
begin
	while(exploding !=0 or shot !=0);//let explosions happen :)
		frame;
	end;
	changewind();//seperate process, it might get messy otherwise :)
  for(i=0; i<nbplayers; i++);//wake all tanks up, so they can fall :)
		signal(playerid[i],s_wakeup);
		falling += pow(10,i);
	end;
	i=0;
	while(falling !=0 and i <= 100)//let them fall
		frame;
		i++;
	end;
	if(i >100)//something can go wrong with falling, this prevents it from stopping the gameplay :)
		falling=0;
	end;
	for(i=0; i<nbplayers; i++);//freeze all players again :)
		signal(playerid[i],s_freeze);
	end;
	i=0;
	while(i==0)
		turn=(turn+1)mod(nbplayers);//next player's turn
		if(playerid[turn].health>0)//make sure we wake an alive player :D
			signal(playerid[turn],s_wakeup);//and wake that player
			i++;
		end;
	end;
	turndone=0;//and at last, the shot is completed :)
	return;
end;
process changewind()
begin
	wind+=rand(-1,1)*1.0/pow(rand(30,50),2);
	if(abs(wind)>0.01)
		wind = 0.01*wind/abs(wind);
	end;
end;
/*
PPP  RRR   OO     J EEEE  CCC TTTTT  III L    EEEE  SSS
P  P R  R O  O    J E    C      T     I  L    E    S
PPP  RRR  O  O    J EEE  C      T     I  L    EEE   SS
P    R R  O  O J  J E    C      T     I  L    E       S
P    R  R  OO   JJ  EEEE  CCC   T    III LLLL EEEE SSS
*/
// selection //
/*
chooses the right process typefor the given projectile (and with the right arguments :) )
*/
function projectile(x,y,power,angl,tank,kind)
begin
	switch(kind)
	case(0):play_wav(sound[1],1);bullet(x,y,power,angl,0,tank,kind);trail(x,y,power,angl,252);end//tracer
	case(1):play_wav(sound[1],1);bullet(x,y,power,angl,10,tank,kind);end//normal bullet
	case(2):play_wav(sound[1],1);bullet(x,y,power,angl,15,tank,kind);end//big bullet
	case(3):play_wav(sound[1],1);bullet(x,y,power,angl,20,tank,kind);end//earth eater
	case(4):play_wav(sound[1],1);bullet(x,y,power,angl,30,tank,kind);end//Big earth eater
	case(5):play_wav(sound[1],1);bullet(x,y,power,angl,10,tank,kind);end//normal ball
	case(6):play_wav(sound[1],1);bullet(x,y,power,angl,15,tank,kind);end//big ball
	case(7):play_wav(sound[0],0);rapidfire(x,y,power,angl,tank,kind,252);end//rapid fire
	case(8):play_wav(sound[1],1);leaper(x,y,power,angl,10,tank,kind,252);end//leaper
	case(9):play_wav(sound[0],0);rapidfire(x,y,power,angl,tank,kind,-1);end//flow
	case(10):play_wav(sound[1],1);bullet(x,y,power,angl,20,tank,kind);trail(x,y,power,angl,252);end//funky
	end;
	nextplayer();
	return;	
end;
// moving processes //
/*
a bullet, is shot from the tank at location x,y with given power and angle.
the acceleration in the y direction is the gravity, in the x direction is the wind.
*/
process bullet(x,y,power,angl,radius,tank,kind)
private
	ox;//x value of where the bullet originates
	oy;//same for y
	float vx;//starting speed in x value
	float vy;//y
	float ax;//acceleration in x direction
	float ay;//y
	tmr;//value of the timer[0]when the shot was fired :)
	i;
	hit;
	tankhit;
	xhit;
begin
	shot++;
	graph=17;
	ox=x+10*sin(angl);
	oy=y-10*cos(angl);//tiny correction :)
	vx=sin(angl)*power/30;//calulating x and y velocity
	vy=-cos(angl)*power/30;
	ax=wind;
	ay=gravity;
	tmr = timer[0];
	hit=calculatehit(ox,oy,vx,vy,ax,ay);
	loop
		x=ox+vx*(timer[0]-tmr)+ax*(timer[0]-tmr)*(timer[0]-tmr)/2;//calculating the position at the current time
		y=oy+vy*(timer[0]-tmr)+ay*(timer[0]-tmr)*(timer[0]-tmr)/2;
		if(hit<=timer[0]-tmr)//we hit something :)
			tankhit=gettankhit(ox,oy,vx,vy,ax,ay);
			xhit=ox+vx*hit+ax*hit*hit/2;
			if(tankhit == 0 and xhit>=0 and xhit<320)//we hit earth :)
				impact(xhit,x=oy+vy*hit+ay*hit*hit/2,radius,tank,kind);
			elseif(xhit>=0 and xhit<320)//we hit a tank, so the explosion is on the tank we hit :)
				impacttank(tankhit.x,tankhit.y,radius,tank,kind);
			else
				impact(0,0,0,0,-1);
			end;
			return;
		end;
		frame; 
	end;
end;
process trail(x,y,power,angl,color)
private
	ox;//x value of where the bullet originates
	oy;//same for y
	float vx;//starting speed in x value
	float vy;//y
	float ax;//acceleration in x direction
	float ay;//y
	tmr;//value of the timer[0]when the shot was fired :)
	i;
	hit;
	tankhit;
	xhit;
	lasttmr;
begin
	ox=x+10*sin(angl);
	oy=y-10*cos(angl);//tiny correction :)
	vx=sin(angl)*power/30;//calulating x and y velocity
	vy=-cos(angl)*power/30;
	ax=wind;
	ay=gravity;
	tmr = timer[0];
	lasttmr=tmr;
	hit=calculatehit(ox,oy,vx,vy,ax,ay);
	loop
		for(i=lasttmr-tmr;i<=timer[0]-tmr && hit>i;i++)
			x=ox+vx*(i)+ax*(i)*(i)/2;//calculating the position at the current time
			y=oy+vy*(i)+ay*(i)*(i)/2;
			put_pixel(x,y,color);
		end;
		lasttmr=timer[0];
		if(hit<=timer[0]-tmr)//we hit something :)
			tmr = timer[0];
			lasttmr=tmr;
			while(hit>=lasttmr-tmr)
				for(i=lasttmr-tmr;i<=timer[0]-tmr && hit>i;i++)
					x=ox+vx*(i)+ax*(i)*(i)/2;//calculating the position at the current time
					y=oy+vy*(i)+ay*(i)*(i)/2;
					put_pixel(x,y,getcolor(y,landcolors[2],landcolors[3]));
				end;
				lasttmr=timer[0];
				frame;
			end;
			return;
			end;
		frame; 
	end;
end;
process roller(x,radius,tank,bullet)
private
 direction;
 i;
 col;
begin
	graph = 17;
	y=terra[x]-2;
	while(direction ==0 and i < 10 )
		 i++;
		 if(x-i>=0  and terra[x-i]>terra[x])direction = -1;end
		 if(x+i<320 and terra[x+i]>terra[x])direction = 1;end
	end;
	while(terra[x+direction]>=terra[x] and col == 0 and direction !=0 and terra[x]<=240)
		col = COLLISION(type tank);
		x+=direction;
		y=terra[x]-2;
		frame;
	end;
	if(y>240)y=240;end
	if(col == 0)
		impact(x,y,radius,tank,bullet);
	else
		impact (col.x,col.y,radius,tank,bullet);
	end;
	return;
end;
process leaper(x,y,power,angl,radius,tank,kind,color)
private
	i;
	bullet;	
begin
	for(i=1; i=<3; i++);
	  bullet=bullet(x,y,power/i,angl,(6-i)*2,tank,kind);
	  if(color>=0)
			trail(x,y,power/i,angl,color);
		end;
	  while(shot !=0)
	  	frame;
	  	if(exists(bullet))
	  		x=bullet.x;
	  		y=bullet.y;
	  	end;
	  end;
	end;
end;
process rapidfire(x,y,power,angl,tank,kind,color)
private 
	i;
	rander;
begin 
	for(i = 0; i<=12; i++);
		if(i%3 == 0)
			rander=1000*rand(-6,6);
			bullet(x,y,power,angl+rander,5,tank,kind);
			if(color>=0)
				trail(x,y,power,angl+rander,color);
			end;
		end;
		frame; 	
	end;
	return;
end;
process funky(x,y,tank)
private
	i;
	rander;
begin
	for(i=-2;i<3;i++)
		rander = rand(25,70);
		bullet(x,y,rander,20000*i,10,tank,1);
		trail(x,y,rander,20000*i,252);
	end;
	return;
end;
// impact selection //
function impact(x,y,radius,tank,kind)
begin
	switch(kind)
	case(-1):shot--;end
	case(0):shot--;end
	case(1):play_wav(sound[2],1);explosion(x,y,radius,tank,15,25);end
	case(2):play_wav(sound[2],1);explosion(x,y,radius,tank,15,45);end
	case(3):play_wav(sound[2],1);explosion(x,y,radius,tank,22,0);end
	case(4):play_wav(sound[2],1);explosion(x,y,radius,tank,22,0);end
	case(5):roller(x,radius,tank,1);end
	case(6):roller(x,radius,tank,2);end
	case(7):play_wav(sound[2],1);explosion(x,y,radius,tank,15,15);end;
	case(8):play_wav(sound[2],1);explosion(x,y,radius,tank,15,radius*2.5);end;
	case(9):roller(x,radius,tank,7);end
	case(10):play_wav(sound[2],1);explosion(x,y,radius,tank,15,25);funky(x,y,tank);end;
	end;
	return;	
end;
function impacttank(x,y,radius,tank,kind)
begin
	switch(kind)
	case(-1):shot--;end
	case(0):shot--;end
	case(1):play_wav(sound[2],1);explosion(x,y,radius,tank,15,25);end
	case(2):play_wav(sound[2],1);explosion(x,y,radius,tank,15,45);end
	case(3):play_wav(sound[2],1);explosion(x,y,radius,tank,22,0);end
	case(4):play_wav(sound[2],1);explosion(x,y,radius,tank,22,0);end
	case(5):play_wav(sound[2],1);explosion(x,y,radius,tank,15,25);end 
	case(6):play_wav(sound[2],1);explosion(x,y,radius,tank,15,45);end
	case(7):play_wav(sound[2],1);explosion(x,y,radius,tank,15,15);end;
	case(8):play_wav(sound[2],1);explosion(x,y,radius,tank,15,radius*2.5);end;
	case(9):play_wav(sound[2],1);explosion(x,y,radius,tank,15,15);end;
	case(10):play_wav(sound[2],1);explosion(x,y,radius,tank,15,25);funky(x,y,tank);end;
	end;
	return;	
end;
// functions //
/*
calculates when a bullet will hit something :)
*/
function calculatehit(ox,oy,float vx,float vy,ax,ay)
private
	t=0;
	hit;
begin
	graph=14;//a graph to check colission with :)
	while(hit == 0 and !COLLISION(type tank))//as long as we hit nothing :)
		x=ox+vx*t+ax*t*t/2;//calculating the position at the current time
		y=oy+vy*t+ay*t*t/2;
		if(x>=0 and x<width and terra[x]<=y)//we're on the screen, and hit the earth :)
			hit = 1;
		end;
		if(x<-30 or x>350 or y >240)//this is far enough out of screen for any bullet :p
			hit = 1;
		end;
		t++;
	end;
	t--;
	return t;
end;
/*
basically the same as calculate hit, only it returns what gets hit :)
*/
function gettankhit(ox,oy,float vx,float vy,ax,ay)
private
	t=0;
	col;
begin
	graph=14;
	while(terra[x]>y and col==0)
		x=ox+vx*t+ax*t*t/2;//calculating the position at the current time
		y=oy+vy*t+ay*t*t/2;
		col = COLLISION(type tank);
		t++;
	end;
	return col;
end;
/*
generates an explosion at the given coordinates, will also cause land to get destroyed
*/
// explosions //	
process explosion(x,y,radius,tank,graph,damage);
begin
	exploding++;
	size = 10;//we scale it :)
	damage(x,y,radius,tank,damage);
	while(size <=radius*8)//and then we let it grow :) (wich explosions usually do :) ), at a radius of 12.5 pixels our bitmap will grow to at least full size, it's 25*25 pixels, so i's radius is also 12.5 :)
		size +=15;//per 15 or so
		frame;//and we show it every time :)
	end;
	drawcircle(x,y,radius);//and when it's done exploding we must modify the land :)
	exploding--;
	if(tank>=0)shot--;end//we'll give -1 as tank when a tank explodes :)
	return; 
end;
/*
does damage to the hit tanks :)
*/
process damage(x,y,radius,tank,damage)
private
	i;
	distance;
	float f;
begin
	for(i=0; i<nbplayers; i++)
		distance=get_dist(playerid[i]);
		distance-=5;//we make a circle of 5 pixel around the tank where you fully hit it :)
		if(distance <0)
			distance=0;
		end;
		if(distance<radius and playerid[i].health>0)
			f = radius-distance;
			f=f/radius;
			playerid[i].health-=f*damage;
			if(i!=tank && tank >=0)
				playerdamage[i][tank]+=f*damage;//keeping up with the array that holds how much damage who has done to who :)
				playerscore[tank]+=25*f*damage;
				playermoney[tank]+=25*f*damage;
			end;
			if(playerid[i].health <=0)
				signal(playerid[i],s_wakeup);//making sure they get the chance to explode!!!
				frame;
				signal(playerid[i],s_freeze);
			end;
		end;
	end;
	return;
end;
/*
TTTTT  AA  N   N K  K  SSS
  T   A  A NN  N K K  S
  T   AAAA N N N KK    SS
  T   A  A N  NN K K     S
  T   A  A N   N K  K SSS
*/
function getposition(tank)
private
	i;
	j;
	returner;
	value;
	maxvalue=-1;
	random;
begin
if(tank==0)
	return rand(10,310);
end;
	for(i=0; i<5*tank; i++)
		value=1;
		random = rand(10,310);
		for(j=0; j<tank; j++)
			value*=getterraininbetween(random,playerid[j].x);	
		end;
		if(value>maxvalue)
			maxvalue=value;
			returner = random;
		end;
	end;
	return (returner);
end;
/*
calculates the land in between two points on the current terrain
the more the better (harder to hit the tanks), is used by
getposition(tank)
*/
function getterraininbetween(start,stop)
private 
	i;
	float rico;
	returner=0;
begin
	if(abs(start-stop)<15)//no use calculating if they're very close, it's a bad situation
		return 0;
	end;
	if(start>stop)//switch if start is the heighest value :)
		i=start;
		start=stop;
		stop=i;
	end;
	rico = terra[stop]-terra[start];
	rico = rico/(stop-start);
	for(i=1; i<stop-start; i++)
		if((terra[start]+i*rico - terra[start+i])> 0)
			returner +=(terra[start]+i*rico - terra[start+i]);
		end;  	
	end;
	return returner+stop-start;
end;
/*
shows an crosshair :)
*/
process crosshair()
begin
	graph = 17;
	loop
		frame;
	end;
end; 
/*
shows an arrow :)
*/
process arrow()
begin
	graph = 16;
	loop
		frame;
	end;
end;
/*
the barrel of a tank, with given color, the tank must set the angle
and alter the the position if it moves.
*/
process barrel(x,y,color)
begin
	resolution = 10;//in order to get it drawn at as many as possible angles :)
	x*=10;
	y*=10;
	y-=10;//repositioning it a bit :), trial and error determined ;)
	x+=10;
	graph=color+6;//check the fpg, this will be the id of the barrel bitmap:)
	set_center(0,color+6,1,3);//we alter the center of the barrel to it's bottom pixel, so it'll rotate around that one
	loop
		frame;//and we also want to show the barrel, might be usefeul you know
	end;
end;
/*
a tank, will also create a barrel which it will aim and move.
*/
process tank(x,color,ai,number)
private 
	i;
	barrel;//process id of the barrel of this tank.
	hy;
	//computer player variables
	target;//current target for this (computer) player
	cpower;//power at which the computer fires
	cangle;//angle
	cbussy;//wether he's aiming or not
	cdist;//how far his shot will land from the target :)
	chit;//wether the last shot was a good shot (little correction needed) or a bad one (completely new generation of a shot)
	dropping;
	pwoften;
	healthtext;
begin
	//initialisation
	y=240;//we'll raise the tank until it's levelled with the land
	graph=color;// check the fpg, this will be the id of the tank bitmap
	for(i=x-3; i<=x+3; i++)//we'll check the land over it's entire width
		if(terra[i]-3<y)//if the current piece of supporting land is higher than the tank is at
			y=terra[i]-3;//we move the tank until that height :)
		end;
	end;
	healthtext = write_int(0,x,y-26,4,&health);
	pwoften = pow(10,number);
	barrel = barrel(x,y,color);//we create a barrel at this tank's coordinates :)
	//loop
	loop//and now we can loop to check all that has to be checked :), and to draw ofcourse :)
	//checking height
		hy = 240;//the enxt lines determine the currently highest piece of land supporting this tank
		for(i=x-3; i<=x+3; i++)
			if(terra[i]-3<hy)
			  hy=terra[i]-3;
			end;
		end;
	//dropping
		if(y<hy and y<240)//and if it's lower than our tank's height, it starts dropping :)
			y+=2;
			DELETE_TEXT(healthtext);
			if(health >0)
				healthtext = write_int(0,x,y-26,4,&health);
			end;
			barrel.y+=20;//yes the barrel also moves (per 10, since it's at resolution 10)
			health-=1;
		elseif(falling mod(pwoften*10) >= pwoften)
			falling -= pwoften; 
		end;
	//exploding
		if(graph !=0 and health <=0)
			playerscore[turn]+=2500;
			playermoney[turn]+=2500;
			explosion(x,y,10,-1,15,25);
			graph =0;
			barrel.graph = 0;
			alive--;
			DELETE_TEXT(healthtext);
		end;
	//aim the barrel :)
		barrel.angle = -(shootangle+10000);//and don't forget to aim the barrel!!!
	//shooting
		if(playerid[turn]==ID&&turndone==0)
			//computer shooting generation 
			if(cbussy == 0&& ai!=0);
				frame;
				if(target != gettarget(number));//if we get a new target
					chit=0;
					target = gettarget(number);//and it becomes our new target :)
					cpower = generatepower(number,target);
				end;
				if(chit==0)//new target, generate a first shot :)
					cdist = getpowerandangle(target,x,y,generatepower(number,target),1,10,color);
					cpower = cdist mod(1000);
					cangle = ((cdist-cpower)mod(1000000))-90000;
					cdist = (cdist-cangle-cpower)/1000000;
					chit = 1;//we generated a power, little adjustments needed now :)
				else//shot has been generated, smaller corrections needed
					cdist = getnewpowerandangle(target,x,y,1,cpower, cangle,color);
					cpower = cdist mod(1000);
					cangle = ((cdist-cpower)mod(1000000))-90000;
					cdist = (cdist-cangle-cpower)/1000000;
					if(cdist > 25)
						cpower +=10;
					end;
					if(calculatehitx(z=x+10*sin(shootangle),z=y-10*cos(shootangle),sin(shootangle)*power/30,-cos(shootangle)*power/30,wind,gravity)<=-30 or calculatehitx(x+10*sin(shootangle),y-10*cos(shootangle),sin(shootangle)*power/30,-cos(shootangle)*power/30,wind,gravity)>350)
						target=-1;//the shot was seriously off :)
					end;
				end;
				cpower +=rand(0,3-ai)*rand(-5+ai,5-ai);
				cangle +=1000*rand(0,3-ai)*rand(-8+2*ai,8-2*ai); 
				if(cpower >100)cpower = 100;end;
				if(cpower <0) cpower = 0;end;
				if(cangle>90000)cangle = 90000;end;
				if(cangle<-90000)cangle = -90000;end;
				weapon = getweapon(number, target,x,y,cpower,cangle,ai,cdist);
				cbussy = 1;
			end;
	//human shooting
			if(ai==0)//if a shot has been fired, you don't have to be able to alter anything :)
				//is a valid weapon selected?
				if(playerweapons[number][weapon]==0)
					while(playerweapons[number][++weapon] ==0)if(weapon >nbweapons-1)weapon =-1;end;end;
				end; 
				if(key(_up)&&power<100)power++;end//we can alter it's settings like this :)
				if(key(_down)&&power >0)power--;end
				if(key(_left) and shootangle>=-90000)shootangle-=1000;end
				if(key(_right) and shootangle<=90000)shootangle+=1000;end
				if(key(_tab))while(playerweapons[number][++weapon] ==0)if(weapon >nbweapons-1)weapon =-1;end;end;wait(10);frame;end
				if(key(_backspace))while(playerweapons[number][--weapon] ==0)if(weapon <0) weapon =nbweapons;end;end;wait(10);frame;end
				if(key(_control)&& shot==0)//and ofcourse fire a bullet, would be boring otherwise :)
					projectile(x,y,power,shootangle,number,weapon);
					if(playerweapons[number][weapon]>0)
						playerweapons[number][weapon]--;
					end;
					turndone=1;
				end	
			end;
	//computer shooting
			if(ai!=0)
				if(power<cpower)power++;end
				if(power>cpower)power--;end
				if(shootangle>cangle)shootangle-=1000;end
				if(shootangle<cangle)shootangle+=1000;end
				if(shootangle == cangle && power == cpower)//and ofcourse fire a bullet, would be boring otherwise :)
					projectile(x,y,power,shootangle,number,weapon); 
					cbussy = 0;
					turndone=1;
					if(playerweapons[number][weapon]>0)
						playerweapons[number][weapon]--;
					end;
				end	
			end;
		end;
		frame;
	end;
end;
/*
 AA   III
A  A   I
AAAA   I
A  A   I
A  A  III
*/
function getweapon(attacker, target,x,y,wpower,wshootangle,ai,shortdist)
private
	distance;
	hit;
	weapons[20];// if a weapontype is useful
	number=0;
	i;
	idtester;
begin
	if(target<0 or target >=nbplayers)
		return 1;
		write(0,160,120,4,"Wrong target");
	end;
	for(i=0; i<nbplayers; i++)
		if(father == playerid[i])
			idtester = 1;
		end
	end;
	if(idtester ==0)
		write(0,160,120,4,"invalid process as father");
		father = playerid[turn];
	end;
	hit = calculatehitx(x+10*sin(wshootangle),y-10*cos(wshootangle),sin(wshootangle)*wpower/30,-cos(wshootangle)*wpower/30,wind,gravity);
	distance= abs(hit - playerid[target].x);
	if(tanksinradius(hit,(4-ai)*5,attacker)>0)//we more or less hit something
		if(playerweapons[attacker][2]!=0)
			weapons[number++]=2;//big grenade useful
		elseif(playerweapons[attacker][1]!=0)//no big grenades, but we do have little grenades	
			weapons[number++]=1;//grenade useful
		end;
	end
	if(terra[hit]+10<playerid[target].y)//we hit higher ground
		if(distance <50)//and more or less hit :)
			if(playerweapons[attacker][9]!=0)
				weapons[number++]=9;//rollers
			elseif(playerweapons[attacker][6]!=0)
				weapons[number++]=6;
			elseif(playerweapons[attacker][5]!=0)
				weapons[number++]=5;
			end
		else//pretty far miss :s
			if(playerweapons[attacker][4]!=0)
				weapons[number++]=4;//dig away whatever is bothring us
			elseif(playerweapons[attacker][3]!=0)
				weapons[number++]=3;
			end
		end;
	end;
	if(tanksinradius(hit,15,attacker)>1)//several tanks near where we shoot :)
		if(playerweapons[attacker][10]!=0)
			weapons[number++]=10;
		elseif(playerweapons[attacker][7]!=0)
			weapons[number++]=7;
		end
	end;
	if(shortdist<30 and shortdist !=0)//we're shooting close, perhaps a bit too short 
		if(playerweapons[attacker][8]!=0)
			weapons[number++]=8;
		end
	end;
	if(number ==0)
		for(x=0; x<nbweapons; x++)
			if(playerweapons[attacker][x]!=0)
				weapons[number++]=x;
			end;
		end;
	end;
	return weapons[rand(0,number-1)];
end;
function tanksinradius(x,radius,attacker)
private 
	returner;
	i;
begin
	returner=0;
	for(i=0; i<nbplayers;i++)
		if(abs(playerid[i].x -x) <= radius && i!=attacker)
			returner++;
		end;
	end; 
	return(returner);
end;
function generatepower(attacker,target)
private 
	distance;
	obstacle;
	returner;
begin
	distance = abs(playerid[attacker].x-playerid[target].x)+playerid[attacker].y-playerid[target].y;
	obstacle = getterraininbetween(playerid[attacker].x,playerid[target].x);
	returner = sqrt((distance/2+sqrt(obstacle))/5)*10;
	if(returner >=90)
		return rand(80,100);
	end;
	return returner;				
end;
function gettarget(current)
private
	i;
	besttarget=-1;
	compare;
begin
	compare=320;//we'll use compare to look for the nearest tank :)
	for(i=0;i<nbplayers;i++)
		if(current != i and playerid[i].health >0 and abs((playerid[i].x) - (playerid[current].x))<compare and abs((playerid[i].x) - (playerid[current].x))>20);
			compare = abs((playerid[i].x) - (playerid[current].x));
			besttarget =i;
		end;
	end;
	compare = 0;//now we'll use compare to look for the tank who did this tank the most damage
	for(i=0;i<nbplayers;i++)
		if(current != i and playerid[i].health >0 and  playerdamage[current][i]>compare);
			compare = playerdamage[current][i];
			besttarget = i;
		end;
	end;
	if(besttarget<0 or besttarget >=nbplayers)
		for(i=0; i<nbplayers; i++)
			if(playerid[i].health >0)
				besttarget = i;
			end;
		end;
	end;
	return besttarget;
end;
/*
calculates where a bullet will hit something :)
*/
function calculatehitx(ox,oy,float vx,float vy,ax,ay)
private
	t=0;
	hit;
begin
	graph=14;
	while(hit == 0 and !COLLISION(type tank))//as long as we hit nothing :)
		x=ox+vx*t+ax*t*t/2;//calculating the position at the current time
		y=oy+vy*t+ay*t*t/2;
		if(x>=0 and x<width and terra[x]<=y)//we're on the screen, and hit the earth :)
			hit = 1;
		end;
		if(x<-30 or x>350 or y >240)//this is far enough out of screen for any bullet :p
			hit = 1;
		end;
		t++;
	end;
	t--;
	return x;
end;
/*
calculates the distance of the hit with current settings to the enemy
*/
function getdistance(target,x,y,shootangle,power)
private
begin
	return abs(calculatehitx(x+10*sin(shootangle),y-10*cos(shootangle),sin(shootangle)*power/30,-cos(shootangle)*power/30,wind,gravity)- playerid[target].x);
end;
/*
calculates the power and angle to hit a given target :)
(to make the invincible opponent :p
*/
function getpowerandangle(target,x,y,power,accuracy,minpower,graph)
private
	i;
	j=0;
	hit;
	best=400;
	returner=90100;
begin
	for(i=-90; i<=90; i+=2)
		frame;
		hit = calculatehitx(x+10*sin(i*1000),y-10*cos(i*1000),sin(i*1000)*power/30,-cos(i*1000)*power/30,wind,gravity);
		if(abs(hit - playerid[target].x)<best)
			best = abs(hit - playerid[target].x); 
			returner = best*1000000+1000*(i+90)+power;
			if(x>playerid[target].x)
				if(hit - playerid[target].x>=0) 
					returner = best*1000000+1000*(i+90)+power;
				else
					returner =1000*(i+90)+power;
				end
			else
				if(hit - playerid[target].x<=0) 
					returner = best*1000000+1000*(i+90)+power;
				else
					returner =1000*(i+90)+power;
				end
			end;
		end;
		if(abs(hit - playerid[target].x)>100 and i < 80)
			i+=10;
		end;
	end;
	return returner;
end;
function getnewpowerandangle(target,x,y,accuracy,origpower,shootangle,graph)
private
	i;
	hit;
	best=400;
	returner=90100;
begin
	power = 0;
	while(best > accuracy && power <=5 && (power+origpower)<=100)
		for(i=shootangle-5000; i<=shootangle+5000; i+=1000)
			frame;
			hit = calculatehitx(x+10*sin(i),y-10*cos(i),sin(i)*(origpower+power)/30,-cos(i)*(origpower+power)/30,wind,gravity);
			if(abs(hit - playerid[target].x)<best)
				best = abs(hit - playerid[target].x);
				if(x>playerid[target].x)
					if(hit - playerid[target].x>=0) 
						returner = best*1000000+(i+90000)+power+origpower;
					else
						returner =(i+90000)+power+origpower;
					end
				else
					if(hit - playerid[target].x<=0) 
						returner = best*1000000+(i+90000)+power+origpower;
					else
						returner =(i+90000)+power+origpower;
					end
				end;
			end;
			hit = calculatehitx(x+10*sin(i),y-10*cos(i),sin(i)*(origpower-power)/30,-cos(i)*(origpower-power)/30,wind,gravity);
			if(abs(hit - playerid[target].x)<best)
				best = abs(hit - playerid[target].x); 
				if(x>playerid[target].x)
					if(hit - playerid[target].x>=0) 
						returner = best*1000000+(i+90000)+power+origpower;
					else
						returner =(i+90000)+power+origpower;
					end
				else
					if(hit - playerid[target].x<=0) 
						returner = best*1000000+(i+90000)+power+origpower;
					else
						returner =(i+90000)+power+origpower;
					end
				end;
			end;
		end;
		power++;
	end;
	return returner;
end;
/*
L     AA 	N   N DDD   M   M  OO  DDD
L    A  A NN  N D  D  MM MM O  O D  D
L    AAAA	N N N D  D  M M M O  O D  D
L    A  A N  NN D  D  M   M O  O D  D
LLLL A  A N   N DDD  	M   M  OO  DDD
*/
function drawcircle (x,y,r)
private
	i;
	j;
	hght;
begin
	for(i=-r; i<=r; i++)//cover the entire radius :)
		hght=sqrt(r*r-i*i);//calculating the height at that point (in a circle x+y = r)
		if(x+i<width and x+i >=0 and y-hght>=terra[x+i])//here the affected part is completely in the earth, so the full amount gets destroyed :)
			terra[x+i]+=2*hght+1;
			drawvline(x+i,terra[x+i]-2*hght-1,terra[x+i],landcolors[2],landcolors[3],landcolors[0],landcolors[1]);
		else
			if(x+i<width and  x+i >=0 and y+hght>=terra[x+i])//here a part of the explosion is above the ground, so we don't do full damage to the terrain
				terra[x+i]=y+hght;
				drawvline(x+i,y-hght,terra[x+i],landcolors[2],landcolors[3],landcolors[0],landcolors[1]);
			end;
		end; 
	end;
end;